QXmpp: QXmppJingleIq Class Reference

QXmpp Version: 1.14.3

Loading...
Searching...
No Matches
QXmppJingleIq Class Reference
Stanzas

The QXmppJingleIq class represents an IQ used for initiating media sessions as specified by XEP-0166: Jingle. More...

`#include <QXmppJingleData.h>`

Inheritance diagram for QXmppJingleIq:

## Classes
struct | RtpSessionStateActive
struct | RtpSessionStateHold
struct | RtpSessionStateUnhold
struct | RtpSessionStateMuting
struct | RtpSessionStateRinging

## Public Types
enum | Action { ContentAccept , ContentAdd , ContentModify , ContentReject , ContentRemove , DescriptionInfo , SecurityInfo , SessionAccept , SessionInfo , SessionInitiate , SessionTerminate , TransportAccept , TransportInfo , TransportReject , TransportReplace }
| This enum is used to describe a Jingle action.
enum | Creator { Initiator , Responder }
using | RtpSessionState = std::variant<RtpSessionStateActive, RtpSessionStateHold, RtpSessionStateUnhold, RtpSessionStateMuting, RtpSessionStateRinging>
using | Reason = QXmppJingleReason
| Alias to QXmppJingleReason for compatibility.
Public Types inherited from QXmppIq
enum | Type { Error = 0 , Get , Set , Result }
| This enum describes the type of IQ. More...

## Public Member Functions
| QXmppJingleIq ()
| Constructs a QXmppJingleIq.
| QXmppJingleIq (const QXmppJingleIq &other)
| Copy-constructor.
| QXmppJingleIq (QXmppJingleIq &&)
| Move-constructor.
QXmppJingleIq & | operator= (const QXmppJingleIq &other)
| Assignment operator.
QXmppJingleIq & | operator= (QXmppJingleIq &&)
| Move-assignment operator.
Action | action () const
void | setAction (Action action)
void | addContent (const Content &content)
QList< Content > | contents () const
void | setContents (const QList< Content > &contents)
QString | initiator () const
| Returns the session initiator.
void | setInitiator (const QString &initiator)
| Sets the session initiator.
std::optional< QXmppJingleReason > | actionReason () const
void | setActionReason (const std::optional< QXmppJingleReason > &)
QXmppJingleReason & | reason ()
const QXmppJingleReason & | reason () const
QString | responder () const
| Returns the session responder.
void | setResponder (const QString &responder)
| Sets the session responder.
bool | ringing () const
void | setRinging (bool ringing)
QString | sid () const
| Returns the session ID.
void | setSid (const QString &sid)
| Sets the session ID.
QString | mujiGroupChatJid () const
void | setMujiGroupChatJid (const QString &mujiGroupChatJid)
std::optional< RtpSessionState > | rtpSessionState () const
void | setRtpSessionState (const std::optional< RtpSessionState > &rtpSessionState)
Public Member Functions inherited from QXmppIq
| QXmppIq (QXmppIq::Type type=QXmppIq::Get)
| QXmppIq (const QXmppIq &other)
| Constructs a copy of other.
| QXmppIq (QXmppIq &&)
| Default move-constructor.
QXmppIq & | operator= (const QXmppIq &other)
| Assigns other to this IQ.
QXmppIq & | operator= (QXmppIq &&)
| Move-assignment operator.
QXmppIq::Type | type () const
void | setType (QXmppIq::Type)
bool | isXmppStanza () const override
Public Member Functions inherited from QXmppStanza
| QXmppStanza (const QString &from=QString(), const QString &to=QString())
| QXmppStanza (const QXmppStanza &other)
| Constructs a copy of other.
| QXmppStanza (QXmppStanza &&)
| Move constructor.
| ~QXmppStanza () override
| Destroys a QXmppStanza.
QXmppStanza & | operator= (const QXmppStanza &other)
| Assigns other to this stanza.
QXmppStanza & | operator= (QXmppStanza &&)
| Move-assignment operator.
QString | to () const
void | setTo (const QString &)
QString | from () const
void | setFrom (const QString &)
QString | id () const
void | setId (const QString &)
QString | lang () const
void | setLang (const QString &)
QXmppStanza::Error | error () const
std::optional< Error > | errorOptional () const
void | setError (const QXmppStanza::Error &error)
void | setError (const std::optional< Error > &error)
QXmppElementList | extensions () const
void | setExtensions (const QXmppElementList &elements)
QList< QXmppExtendedAddress > | extendedAddresses () const
void | setExtendedAddresses (const QList< QXmppExtendedAddress > &extendedAddresses)
std::optional< QXmppE2eeMetadata > | e2eeMetadata () const
void | setE2eeMetadata (const std::optional< QXmppE2eeMetadata > &e2eeMetadata)
Public Member Functions inherited from QXmppNonza
virtual void | parse (const QDomElement &)=0
virtual void | toXml (QXmlStreamWriter *writer) const =0

## Detailed Description

The QXmppJingleIq class represents an IQ used for initiating media sessions as specified by XEP-0166: Jingle.

## Member Typedef Documentation

## ◆ RtpSessionState

using QXmppJingleIq::RtpSessionState = std::variant<RtpSessionStateActive, RtpSessionStateHold, RtpSessionStateUnhold, RtpSessionStateMuting, RtpSessionStateRinging>

Contains the state of an RTP session as specified by XEP-0167: Jingle RTP Sessions Informational Messages.

Since
  QXmpp 1.5

## Member Enumeration Documentation

## ◆ Creator

enum QXmppJingleIq::Creator

Party that originially generated the content type

Since
  QXmpp 1.5

Enumerator
Initiator | The initiator generated the content type.
Responder | The responder generated the content type.

## Member Function Documentation

## ◆ action()

QXmppJingleIq::Action QXmppJingleIq::action | ( |  | ) | const

Returns the Jingle IQ's action.

## ◆ actionReason()

std::optional< QXmppJingleReason > QXmppJingleIq::actionReason | ( |  | ) | const

Returns the reason for the action (in most cases the error).

Since
  QXmpp 1.11

## ◆ addContent()

void QXmppJingleIq::addContent | ( | const Content & | content | ) |

Adds an element to the IQ's content elements.

Since
  QXmpp 0.9.2

## ◆ contents()

QList< QXmppJingleIq::Content > QXmppJingleIq::contents | ( |  | ) | const

Returns the IQ's content elements.

Since
  QXmpp 0.9.2

## ◆ mujiGroupChatJid()

QString QXmppJingleIq::mujiGroupChatJid | ( |  | ) | const

Returns the JID of the XEP-0272: Multiparty Jingle (Muji) group chat.

Returns
  the Muji group chat JID

Since
  QXmpp 1.5

## ◆ reason() [1/2]

QXmppJingleReason & QXmppJingleIq::reason | ( |  | ) |

Returns a reference to the IQ's reason element.

Deprecated
  Deprecated since QXmpp 1.11: Use actionReason() instead.

## ◆ reason() [2/2]

const QXmppJingleReason & QXmppJingleIq::reason | ( |  | ) | const

Returns a const reference to the IQ's reason element.

Deprecated
  Deprecated since QXmpp 1.11: Use actionReason() instead.

## ◆ ringing()

bool QXmppJingleIq::ringing | ( |  | ) | const

Returns true if the call is ringing.

Deprecated
  This method is deprecated since QXmpp 1.5. Use `QXmppJingleIq::rtpSessionState()` instead.

## ◆ rtpSessionState()

std::optional< QXmppJingleIq::RtpSessionState > QXmppJingleIq::rtpSessionState | ( |  | ) | const

Returns the state of an RTP session as specified by XEP-0167: Jingle RTP Sessions Informational Messages.

Returns
  the session's state

Since
  QXmpp 1.5

## ◆ setAction()

void QXmppJingleIq::setAction | ( | QXmppJingleIq::Action | action | ) |

Sets the Jingle IQ's action.

Parameters

  action |

## ◆ setActionReason()

void QXmppJingleIq::setActionReason | ( | const std::optional< QXmppJingleReason > & | reason | ) |

Sets the reason for the action (in most cases the error).

Since
  QXmpp 1.11

## ◆ setContents()

void QXmppJingleIq::setContents | ( | const QList< Content > & | contents | ) |

Sets the IQ's content elements.

Since
  QXmpp 0.9.2

## ◆ setMujiGroupChatJid()

void QXmppJingleIq::setMujiGroupChatJid | ( | const QString & | mujiGroupChatJid | ) |

Sets the JID of the XEP-0272: Multiparty Jingle (Muji) group chat.

Parameters

  mujiGroupChatJid | Muji group chat JID

Since
  QXmpp 1.5

## ◆ setRinging()

void QXmppJingleIq::setRinging | ( | bool | ringing | ) |

Set to true if the call is ringing.

Parameters

  ringing |

Deprecated
  This method is deprecated since QXmpp 1.5. Use `QXmppJingleIq::setRtpSessionState()` instead.

## ◆ setRtpSessionState()

void QXmppJingleIq::setRtpSessionState | ( | const std::optional< RtpSessionState > & | rtpSessionState | ) |

Sets the state of an RTP session as specified by XEP-0167: Jingle RTP Sessions Informational Messages.

The appropriate action is set as well. Thus, it is not needed to set it manually.

Parameters

  rtpSessionState | session's state

Since
  QXmpp 1.5

The documentation for this class was generated from the following files:

- QXmppJingleData.h
- QXmppJingleData.cpp